// CompoundBorder.java
// by Natsha Etcode

/*
RELEASE NOTICE
This software is released into the Public Domain.
There are no restrictions on its use or distribution.

DISCLAIMER
        This software and its documentation are provided "AS IS" and
without any expressed or implied warranties whatsoever.  No warranties
as to performance, merchantability, or fitness for a particular
purpose exist.
        The user is advised to test the software thoroughly before
relying on it.  The user must assume the entire risk and liability of
using this software.  In no event shall any person or organization of
people be held responsible for any direct, indirect, consequential or
inconsequential damages or lost profits.
*/

package winifc.widgets;

import netscape.application.*;
import netscape.util.*;

public class CompoundBorder extends Border {
    Border innerBorder, outerBorder;

    public CompoundBorder(Border outside, Border inside) {
        if(outside == null)
            outerBorder = EmptyBorder.emptyBorder();
        else
            outerBorder = outside;

        if(inside == null)
            innerBorder = EmptyBorder.emptyBorder();
        else
            innerBorder = inside;
    }

    public Border innerBorder() { return innerBorder; }
    public Border outerBorder() { return outerBorder; }

    public int leftMargin() {
        return innerBorder.leftMargin() + outerBorder.leftMargin();
    }

    public int rightMargin() {
        return innerBorder.rightMargin() + outerBorder.rightMargin();
    }

    public int topMargin() {
        return innerBorder.topMargin() + outerBorder.topMargin();
    }

    public int bottomMargin() {
        return innerBorder.bottomMargin() + outerBorder.bottomMargin();
    }

    public void drawInRect(Graphics g, int x, int y, int w, int h) {
        outerBorder.drawInRect(g, x, y, w, h);
        Rect r = outerBorder.interiorRect(x, y, w, h);
        innerBorder.drawInRect(g, r.x, r.y, r.width, r.height);
    }

}

