// WinColor.java
// by Natsha Etcode

/*
RELEASE NOTICE
This software is released into the Public Domain.
There are no restrictions on its use or distribution.

DISCLAIMER
        This software and its documentation are provided "AS IS" and
without any expressed or implied warranties whatsoever.  No warranties
as to performance, merchantability, or fitness for a particular
purpose exist.
        The user is advised to test the software thoroughly before
relying on it.  The user must assume the entire risk and liability of
using this software.  In no event shall any person or organization of
people be held responsible for any direct, indirect, consequential or
inconsequential damages or lost profits.
*/

package winifc.widgets;

import netscape.application.*;
import netscape.util.*;
import java.awt.SystemColor;

public class WinColor {
    // Windows

    public static Color activeCaption = ifc(SystemColor.activeCaption);

    // XXX The AWT doesn't seem to be returning the correct value?  Perhaps I
    // don't understand their terminology.

    public static Color rootView = ifc(SystemColor.control);

    // Controls

    public static Color control = ifc(SystemColor.control);
    public static Color controlHighlight = ifc(SystemColor.controlHighlight);
    public static Color controlLtHighlight =
        ifc(SystemColor.controlLtHighlight);
    public static Color controlShadow = ifc(SystemColor.controlShadow);
    public static Color controlDkShadow = ifc(SystemColor.controlDkShadow);
    public static Color controlText = ifc(SystemColor.controlText);

    // Text

    public static Color text = ifc(SystemColor.window);  // XXX
    public static Color textHighlight = ifc(SystemColor.textHighlight);
    public static Color textInactiveText = ifc(SystemColor.textInactiveText);
    public static Color textHighlightText = ifc(SystemColor.textHighlightText);
    public static Color textText = ifc(SystemColor.textText);

    // ScrollBar

    public static Color scrollbar = ifc(SystemColor.scrollbar);



    // XXX I don't know why, but these special colors caused problems when
    // drawing a ListView in a buffered ScrollView when they were set as the
    // background color of the buffered ScrollView.  Go figure.  As a result,
    // we create a real IFC Color with the values of the awt SystemColors.

    private static Color ifc(java.awt.Color c) {
        return new Color(c.getRed(), c.getGreen(), c.getBlue());
    }
}
