// WinScrollGroup.java
// by Natsha Etcode

/*
RELEASE NOTICE
This software is released into the Public Domain.
There are no restrictions on its use or distribution.

DISCLAIMER
        This software and its documentation are provided "AS IS" and
without any expressed or implied warranties whatsoever.  No warranties
as to performance, merchantability, or fitness for a particular
purpose exist.
        The user is advised to test the software thoroughly before
relying on it.  The user must assume the entire risk and liability of
using this software.  In no event shall any person or organization of
people be held responsible for any direct, indirect, consequential or
inconsequential damages or lost profits.
*/

package winifc.widgets;

import netscape.application.*;
import netscape.util.*;

public class WinScrollGroup extends ScrollGroup {
    public WinScrollGroup(Rect r) {
        this(r.x, r.y, r.width, r.height);
    }

    public WinScrollGroup(int x, int y, int w, int h) {
        super(x, y, w, h);
        setBorder(null);

        scrollView().setBackgroundColor(WinColor.text);
        scrollView().setTransparent(false);
    }

    protected ScrollBar createScrollBar(boolean horizontal) {
        ScrollBar bar;

        if (horizontal) {
            bar = new WinScrollBar(0, 0, bounds.width, 1,
                Scrollable.HORIZONTAL);
        } else {
            bar = new WinScrollBar(0, 0, 1, bounds.height,
                Scrollable.VERTICAL);
        }

        return bar;
    }
}
