// WinIFCExample.java
// by Natsha Etcode

/*
RELEASE NOTICE
This software is released into the Public Domain.
There are no restrictions on its use or distribution.

DISCLAIMER
        This software and its documentation are provided "AS IS" and
without any expressed or implied warranties whatsoever.  No warranties
as to performance, merchantability, or fitness for a particular
purpose exist.
        The user is advised to test the software thoroughly before
relying on it.  The user must assume the entire risk and liability of
using this software.  In no event shall any person or organization of
people be held responsible for any direct, indirect, consequential or
inconsequential damages or lost profits.
*/


import netscape.application.*;
import netscape.util.*;

import winifc.widgets.*;

public class WinIFCExample extends Application implements Target {

    public void init() {
        super.init();

        mainRootView().setColor(WinColor.rootView);
        mainRootView().addSubview(createContents());
        mainRootView().setBuffered(true);
    }

    public static void main(String args[]) {
        ExternalWindow mainWindow;
        Size size;
        WinIFCExample app;

        app = new WinIFCExample();
        mainWindow = new ExternalWindow();
        mainWindow.setTitle("WinIFCExample");
        app.setMainRootView(mainWindow.rootView());
        size = mainWindow.windowSizeForContentSize(270, 278);
        mainWindow.sizeTo(size.width, size.height);
        mainWindow.show();

        app.run();
        System.exit(0);
    }


    private View createContents() {
        ContainerView cv;
        WinButton b;
        Vector v;
        WinComboBox cb;
        WinTextField tf;
        WinProgressBar pb;
        WinLabel l;
        WinListView lv;
        WinListItem li;
        int i;
        WinScrollGroup sg;
        ContainerView cv2;
        TextView tv;

        cv = new ContainerView(0, 1, 270, 277);
        cv.setBackgroundColor(WinColor.rootView);
        cv.setBorder(WinBorder.shallowLoweredBezel());  
        cv.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);
        cv.setVertResizeInstruction(View.HEIGHT_CAN_CHANGE);

        //////////////////////////////////////////////////////
        b = new WinButton(5, 5, 80, 21);
        b.setTitle("WinButton 1");
        cv.addSubview(b);

        b = new WinButton(90, 5, 80, 21);
        b.setTitle("WinButton 2");
        b.setDefault(true);
        cv.addSubview(b);

        b = new WinButton(175, 5, 80, 21);
        b.setTitle("WinButton 3");
        b.setEnabled(false);
        cv.addSubview(b);
        
        //////////////////////////////////////////////////////
        b = WinButton.createWinCheckButton(5, 31, 130, 21);
        b.setTitle("WinButton.Check 1");
        cv.addSubview(b);

        b = WinButton.createWinCheckButton(135, 31, 130, 21);
        b.setTitle("WinButton.Check 2");
        b.setState(true);
        b.setEnabled(false);
        cv.addSubview(b);

        //////////////////////////////////////////////////////
        v = new Vector(5);
        v.addElement("Choice 1");
        v.addElement("Choice 2");
        v.addElement("Choice 3");
        v.addElement("Choice 4");
        v.addElement("Choice 5");

        cb = new WinComboBox(5, 57, 100, 21);
        cb.setTitles(v);
        cb.selectTitle("Choice 1");
        cv.addSubview(cb);

        cb = new WinComboBox(110, 57, 100, 21);
        cb.setTitles(v);
        cb.selectTitle("Choice 1");
        cb.setEnabled(false);
        cv.addSubview(cb);

        //////////////////////////////////////////////////////
        tf = new WinTextField(5, 83, 100, 21);
        tf.setStringValue("WinTextField 1");
        cv.addSubview(tf);

        tf = new WinTextField(110, 83, 100, 21);
        tf.setStringValue("WinTextField 2");
        tf.setTrackEditability(true);
        tf.setEditable(false);
        cv.addSubview(tf);

        //////////////////////////////////////////////////////
        pb = new WinProgressBar(5, 109, 100, 21);
        pb.setTotalCount(10);
        pb.setCurrentCount(5);
        cv.addSubview(pb);

        pb = new WinProgressBar(110, 109, 100, 21);
        pb.setDone(true);
        cv.addSubview(pb);

        //////////////////////////////////////////////////////
        b = new WinButton(5, 135, 100, 21);
        b.setTitle("WinAlert alert");
        b.setTarget(this);
        b.setCommand("alert");
        cv.addSubview(b);

        b = new WinButton(110, 135, 100, 21);
        b.setTitle("WinAlert error");
        b.setTarget(this);
        b.setCommand("error");
        cv.addSubview(b);

        //////////////////////////////////////////////////////
        l = new WinLabel("WinLabel 1");
        l.setBounds(5, 161, 100, 21);
        l.setCommandKey('1');
        cv.addSubview(l);

        l = new WinLabel("WinLabel 2");
        l.setBounds(110, 161, 100, 21);
        l.setCommandKey('2');
        cv.addSubview(l);

        // Setup the WinListView example /////////////////////
        //////////////////////////////////////////////////////
        cv2 = new ContainerView(5, 187, 105, 84);
        cv2.setTitle(null);
        cv2.setBorder(WinBorder.loweredBezel());
        cv2.setBackgroundColor(WinColor.rootView);
        cv2.setTransparent(false);

        //////////////////////////////////////////////////////
        sg = new WinScrollGroup(cv2.interiorRect());
        sg.setHorizScrollBarDisplay(ScrollGroup.NEVER_DISPLAY);
        sg.setVertScrollBarDisplay(ScrollGroup.AS_NEEDED_DISPLAY);

        //////////////////////////////////////////////////////
        lv = new WinListView(0,0,105,0);
        lv.setAllowsMultipleSelection(true);
        lv.setAllowsEmptySelection(true);
        lv.setPrototypeItem(new WinListItem());
        lv.setPageSize(sg.bounds().height);
        for(i = 0; i < 20; i++) {
            li = (WinListItem)lv.addItem();
            li.setTitle("WinListItem " + i);
        }
        lv.sizeToMinSize();

        //////////////////////////////////////////////////////
        sg.setContentView(lv);
        sg.scrollView().setBuffered(true);
        cv2.addSubview(sg);
        cv.addSubview(cv2);

        //////////////////////////////////////////////////////
        // Setup the description panes
        //////////////////////////////////////////////////////
        cv2 = new ContainerView(115, 187, 150, 84);
        cv2.setTitle(null);
        cv2.setBorder(WinBorder.loweredBezel());
        cv2.setBackgroundColor(WinColor.rootView);
        cv2.setTransparent(false);

        sg = new WinScrollGroup(cv2.interiorRect());
        sg.setHorizScrollBarDisplay(ScrollGroup.NEVER_DISPLAY);
        sg.setVertScrollBarDisplay(ScrollGroup.AS_NEEDED_DISPLAY);

        tv = new TextView(sg.scrollView().bounds);
        tv.setUseSingleFont(true);
        tv.setEditable(false);
        tv.setSelectable(false);
        tv.setFont(Font.fontNamed("Courier", Font.PLAIN, 12));
        tv.setBackgroundColor(WinColor.text);
        tv.setTextColor(WinColor.textText);
        tv.setSelectable(true);
        tv.setString("Other classes:\n" 
                    + "WinBorder, \nWinColor, \nWinFont");

        sg.setContentView(tv);
        sg.scrollView().setBuffered(true);
        cv2.addSubview(sg);
        cv.addSubview(cv2);


        return cv;
    }

    public void performCommand(String command, Object object) {
        if("alert".equals(command)) {
            WinAlert.runAlertExternally(WinAlert.alertIcon, "WinAlert",
                        "This is the Alert Dialog", "Ok", "Cancel", null);
        } else if ("error".equals(command)) {
            WinAlert.runAlertExternally(WinAlert.errorIcon, "WinAlert",
                        "This is the Error Dialog", "Ok", "Cancel", null);
        }
    }
    
}
